(*Renaming *)
let const  a _ = a 
let id x = x
let (!) a = const () a
let p1 = fst
let p2 = snd

let either f g x = match x with
  | Either.Left a -> f a
  | Either.Right b -> g b

(*
This is the infix composition operator
 *)
let (<.) f g x= f (g x)

(* (1) Product -------------------------------------------------------*)
let split f g x = (f x, g x)
(*  Example : split ((+) 1) ((+) 3) 5  *)

let (><) f g = split (f <. p1) (g <. p2)

(*dup*)
let diag x = split id id x

(* (2) Coproduct -------------------------------------------------------*)

(*Renaming *)
let i1 x = Either.Left x
let i2 x = Either.Right x

let (-|-) f g x =  either (i1 <. f) (i2 <. g) x

(* McCarthy's conditional *)

let grd p x = if p x then i1 x else i2 x

let cond p f g = ((either f g) <. (grd p))

(*dup*)
let codiag x = either id id x 

(* (3) Exponentiation -------------------------------------------------------*)

let curry f x y = f (x,y) 
let uncurry f (x,y)  = f x y

let ap (f,x) = f x

let expn f = curry (f <. ap)

let p2p p b = if b then (snd p) else (fst p)

(*Natural isomorphisms*)

let swap x = split p2 p1 x

let assocr x = split (p1 <. p1) (p2 >< id) x

let assocl x = split (id >< p1) (p2 <. p2) x

let undistr x = either (id >< i1) (id >< i2) x

let undistl x = either (i1 >< id) (i2 >< id) x

let flatr (a,(b,c)) = (a,b,c)

let flatl ((a,b),c) = (a,b,c)

let br x = split id (!) x

let bl x = split (!) id x

let coswap x = either i2 i1 x

let coassocr x = either (id -|- i1) (i2 <. i2) x

let coassocl x = either (i1<.i1) (i2 -|- id) x

let distl x = uncurry (either (curry i1) (curry i2)) x

let distr x = ((swap -|- swap) <. distl <. swap) x

let colambda (a,b) c = if c then a else b 

let lambda f = (f false, f true)

let singl a = [a] 

let bang = (!)

let dup x = split id id x

let zero x = const 0 x

let one x = const 1 x

let nil (_: 'a list) : 'a list = []

let cons (a,b) = a :: b

let add = uncurry ( + )

let mul = uncurry ( * )

(* mul not working because of comment syntax *)

let conc a b = (uncurry (@)) (a,b)

let umax a b = (uncurry max) (a,b)
